package ema.tpjee.banking.model;

import java.io.Serializable;

import ema.tpjee.banking.model.exceptions.NoAvailableFundsException;



public class Checking extends BankAccount implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = -1575986666936254595L;
	private static final double overdraftPenalty = 25.00;

	public Checking() {
	}

	public Checking(Bank b, String num, double initAmount) {
		super(b, num, initAmount);
	}

	public void withdraw(double val) throws NoAvailableFundsException {
		super.withdraw(val);
		if (getBalance() <= val)
			deductOverDraftPenalty();
	}

	public String accountType() {
		return "Checking Account:       ";
	}

	public String toString() {
		return super.toString() + " " + getMessage();
	}

	private double getOverdraftPenalty() {
		return overdraftPenalty;
	}

	private void deductOverDraftPenalty() {
		if (LOG)
			bank.logBuffer
					.append(
							"try to deduct overdraft penality "
									+ getOverdraftPenalty()).append("\n");
		try {
			super.withdraw(getOverdraftPenalty());
		} catch (NoAvailableFundsException e) {
			bank.logBuffer.append("NoAvailableFundsException thrown ").append(
					"\n");
		}
	}

}
